@import '../../../../node_modules/tocbot/dist/tocbot.css';
@import "tailwind";
@import "variables";
@import "typography";
@import "layout";

/* Header */
a.header-logo {
  @media (max-width: 991px) {
    max-width: 30%;
  }
}
a.header-logo:hover {
  text-decoration: none;
}
.border-light {
  border-color: rgba(255,255,255,.32) !important;
}
.cta-button {
  background-color: var(--cta-button);
  color: var(--white);
  padding: 0.5rem 0.75rem;
  line-height: 1rem;
  border-radius: 0.25rem;
  display: inline-flex;
}
.cta-button:hover {
  text-decoration: none;
  color: var(--white);
}
.skip-link {
  transition: opacity 0.2s linear;

  &:focus {
    background-color: var(--blue-600);
    color: var(--white);
    border: 2px solid var(--white);
    border-radius: 4px;
    clip: auto;
    height: auto;
    opacity: 1;
    overflow: visible;
    padding: .5rem 1rem;
    position: fixed;
    left: 2px;
    text-align: center;
    white-space: normal;
    width: 15rem;
    z-index: 500;
  }
}
/* Versions menu */
.navbar-toggle {
  width: 16px;
  height: 16px;
  background-color: var(--white);
  mask-image: url("../gitlab_ui/svgs/ellipsis_h.svg");
  mask-repeat: no-repeat;
  mask-position: top right;
  position: absolute;
  top: 0;
  right: 1rem;
}
.gl-disclosure-dropdown .gl-button.gl-button.btn-default {
  background-color: var(--t-indigo-500);
  box-shadow: none;
  width: 100%;
  justify-content: left;

  .gl-button-text {
    display: flex;
    justify-content: space-between;
    align-items: center;
    width: 100%;
  }

  @media (min-width: 992px) {
    width: auto;
    justify-content: center;
  }
}
.gl-disclosure-dropdown .gl-button.gl-button.btn-default,
.gl-disclosure-dropdown .gl-button.gl-button.btn-default .gl-icon,
.gl-disclosure-dropdown .gl-button.gl-button.btn-default:active:focus .gl-icon,
.gl-disclosure-dropdown .gl-button.gl-button.btn-default .gl-icon:active {
  color: var(--white);
}
.gl-new-dropdown-contents > li:not(:first-child) {
  margin-top: .25rem;
  padding-top: .25rem;
  border-top: 1px solid var(--gray-200);
}

/* Global navigation */
.global-nav {
  top: var(--header-height);
  bottom: var(--sidebar-button-height);
  font-size: 0.8125rem; /* 13px */
  border-right: 1px solid var(--gray-50);
}
.sidebar-link {
  line-height: 1;
}
.sidebar-link:focus-visible {
  outline-offset: -1px;
}
.sidebar-link.level-1 {
  font-weight: 600;
  padding-left: 1rem;
}
.sidebar-link.level-2 {
  padding-left: calc(var(--sidebar-indent) * 2);
}
.sidebar-link.level-3 {
  padding-left: calc(var(--sidebar-indent) * 3);
}
.sidebar-link.level-4 {
  padding-left: calc(var(--sidebar-indent) * 4);
}
.sidebar-link.level-5 {
  padding-left: calc(var(--sidebar-indent) * 5);
}
.sidebar-link.level-6 {
  padding-left: calc(var(--sidebar-indent) * 6);
}
.sidebar-link.level-7 {
  padding-left: calc(var(--sidebar-indent) * 7);
}
div:has(> .sidebar-link):hover {
  border-radius: 0.25rem;
  background-color: var(--gray-50);
}
.sidebar-link-active-item {
  background-color: var(--gray-50);
  position: relative;
}
.sidebar-link-active-item::before {
  background-color: var(--purple-900);
  border-radius: 4px;
  content: "";
  display: block;
  position: absolute;
  inset: 3px 0 3px 3px;
  width: 3px;
}
/* Section toggle */
.submenu-toggle.gl-button.btn-default,
.submenu-toggle.gl-button.btn-default:active,
.submenu-toggle.gl-button.btn-default:focus {
  background-color: transparent;
}
.submenu-toggle.gl-button.btn-default:focus-visible {
  outline: auto 1px;
}
.submenu {
  overflow: hidden;
}
.submenu-enter-active,
.submenu-leave-active {
  transition: max-height 0.3s ease-out;
  max-height: 100vh;
}
.submenu-enter,
.submenu-leave-to {
  max-height: 0;
}
/* Sidebar collapse */
.sidebar-container:has(.sidebar-collapsed) {
  border-right: 1px solid var(--gray-50);
}
.sidebar-toggle {
  height: var(--sidebar-button-height);
  border: 1px solid var(--gray-50);
  border-style: solid solid none none;
}
.sidebar-collapsed,
.sidebar-collapsed .sidebar-toggle {
  width: var(--sidebar-collapsed-width);
}
.sidebar-collapsed .sidebar-toggle > div {
  justify-content: center;
}
.sidebar-collapsed .sidebar-toggle > div,
.sidebar-collapsed .sidebar-toggle svg {
  margin-left: 0;
}
.sidebar-toggle .gl-button.btn-default,
.sidebar-toggle .gl-button.btn-default:active {
  background-color: transparent;
}
.sidebar-toggle-collapsed.gl-button .gl-button-icon {
  margin-right: 0;
}
/* Sidebar overlay (small width) */
.sidebar-overlay-open {
  z-index: 40;
  position: fixed;
  margin-left: -2rem;

  > div {
    background: var(--white);
    width: 75%;
    max-width: 25rem;
  }
}

/* Modal overlays */
.modal-backdrop {
  top: var(--header-height);
}
.fade-enter-active,
.fade-leave-active {
  transition: opacity 0.15s linear;
}
.fade-enter,
.fade-leave-to {
  opacity: 0;
}

/* Table of contents */
.js-toc {
  position: fixed;
}
.js-toc>.toc-list {
  overflow-y: auto;
  height: calc(100vh - var(--header-height));
  padding: var(--toc-y-offset) 1rem calc(var(--toc-y-offset)) 0;
}
.js-toc.is-position-fixed {
  top: var(--header-height);
}
.js-toc.is-position-fixed>.toc-list {
  padding: var(--toc-y-offset) 1rem var(--toc-y-offset) 0;
}
*:lang(en-US) {
  .js-toc>.toc-list::before {
    content: "On this page";
    font-weight: 600;
    font-size: 1rem;
  }
  .js-toc>.toc-list > li:first-child {
    margin-top: 0.75rem;
  }
}
.toc-list {
  line-height: 1.2;
  list-style-type: none;
  padding-right: 1rem;
}
.toc-link::before {
  background-color: var(--white);
  height: calc(100% - var(--toc-item-spacing));
}
a.toc-link {
 padding: 0 0 var(--toc-item-spacing) 0.75rem;
 display: inline-block;
 position: relative;
}
.is-active-link {
  font-weight: 600;
}
.is-active-link::before {
  background-color: var(--purple-900);
}

/**
 * Docs content
 */
div.docs-content {
  /* Links */
  a:not(svg *) {
    color: var(--purple-700);
    border-bottom: 1px solid rgba(89,67,182,.24);
    transition: .15s linear, border-bottom-color .15s linear;
  }
  a:not(svg *):hover {
    color: var(--purple-900);
    border-bottom: 1px solid var(--purple-900);
    text-decoration: none;
  }
  a[href^="http"]:not([href*="gitlab.com"]):not([href*="docs.gitlab-review.app"]):not([href*="localhost:1313"]):not(.plantuml):not(svg *)::after {
    content: url("../gitlab_ui/svgs/external-link.svg");
    margin-left: 0.25rem;
    display: inline-block;
    vertical-align: middle;
  }
  /* Permalinks */
  a.anchor {
    font-size: 90%;
    padding-left: .25em;
    text-decoration: none;
    opacity: 0;
    border-bottom: 0 !important;
    transition: all .3s;
  }

  h2:hover,
  h3:hover,
  h4:hover,
  h5:hover,
  h6:hover {
    a.anchor {
      opacity: 1;
    }
  }

  a.anchor::before {
    content: '#';
  }

  /* Tables */
  .table-container {
    width: 100%;
    overflow-x: auto;
    overflow-y: hidden;
  }
  table {
    font-size: 0.875rem;
    border-collapse: collapse;
    line-height: 1.5;
    width: 100%;
    margin-bottom: 1.5em;

    thead tr {
      border-top: 0;
    }

    th {
      background-color: var(--white);
      color: var(--gray-950);
      line-height: 1.25;
    }

    th, td {
      padding: 1em;
    }

    tr {
      border-top: 1px solid var(--gray-50);
    }
    tr:last-child {
      border-bottom: 1px solid var(--gray-50);
    }

    td {
      vertical-align: top;
      max-width: 12rem;

      a {
        border-bottom: 1px solid var(--purple-700);
      }

      a:has(strong) {
        border-bottom: 0;
      }
    }
  }

  /* Code samples */
  .highlight {
    background-color: var(--gray-50);
  }
  pre {
    padding: 1rem;
  }
  .clipboard-icon {
    outline: none;
    height: 14px;
    width: 14px;
  }

  *:not(pre)>code {
    background-color: var(--gray-50);
    color: var(--gray-900);
    border-radius: 4px;
    line-height: 1;
    overflow-wrap: break-word;
    padding: 2px;
  }
  a code {
    color: var(--purple-700);
  }
  a:hover code {
    background-color: var(--t-indigo-100);
  }

  /* Alert boxes */
  .alert {
    padding: 1rem 3rem;
    border-radius: 5px;
    border: solid 1px;
    background: 1rem 1.25rem no-repeat;
    p:last-child {
      margin-bottom: 0 !important;
    }
  }
  .alert-type-note {
    border-color: var(--gray-100);
    background-color: var(--gray-10);
    background-image: url("../gitlab_ui/svgs/information-o.svg");
  }
  .alert-type-warning {
    border-color: var(--red-100);
    background-color: var(--red-50);
    background-image: url("../gitlab_ui/svgs/warning.svg");
  }
  .alert-type-flag {
    border-color: var(--green-100);
    background-color: var(--green-50);
    background-image: url("../gitlab_ui/svgs/flag.svg");
  }
  .alert-type-disclaimer {
    border-color: var(--blue-100);
    background-color: var(--blue-50);
    background-image: url("../gitlab_ui/svgs/review-warning.svg");
  }

  /* Blockquotes */
  blockquote {
    padding: 1rem 1rem 0;
    border-radius: 5px;
    border: solid 1px;
    border-color: var(--gray-100);
    background-color: var(--gray-10);
  }

  /* Docs errors */
  .docs-error-box {
    padding: 1rem;
    background: 1rem 1.25rem no-repeat;
    background-color: var(--red-50);
  }

  /* Credit: https://medium.com/@no.steiner/change-svg-icons-color-with-css-only-ba6a4912e6ba */
  .docs-error-icon {
    width: 16px;
    height: 16px;
    margin: 4px 15px 0 0;
    mask: url("../gitlab_ui/svgs/error.svg") no-repeat 50% 50%;
    mask-size: cover;
    background-color: var(--error-icon);
    float: left;
  }

  /* Diagrams */
  .mermaid {
    overflow: auto;
    position: relative;
    z-index: 1;
  }
  .mermaid:not([data-processed='true']) {
    display: none;
  }

  /* Availability and history details */
  .availability,
  .version-history {
    border-left: 2px solid var(--availability-border);
    line-height: 1.65;
  }
  .availability li,
  .history-list li {
    margin-bottom: 0;
  }
  .availability + .version-history {
    margin-top: -1rem;
  }
  .version-history button {
    background: url("../gitlab_ui/svgs/ellipsis_h.svg") 50% / 12px no-repeat;
    width: 1.25rem;
  }
  .history-list ul {
    margin: 0;
    padding: 0 0 0 1.25rem;
  }
  /*
   * Avoid double-bold labels for feature details
   * on the GraphQL reference page, which includes
   * markdown bold tags in its labels.
   *
   * See https://gitlab.com/gitlab-org/technical-writing/docs-gitlab-com/-/issues/194
  */
  .availability .gl-font-bold strong {
    font-weight: 600;
  }

  /* YouTube */
  .fa-youtube-play {
    display: inline-block;
    width: 18px;
    height: 18px;
    background-color: var(--youtube-logo);
    mask-image: url("../fa-icons/youtube.svg");
    vertical-align: text-top;
  }
  .video-fallback {
    display: none;
  }
  .video-container {
    position: relative;
    margin: 1.25rem 0;
    aspect-ratio: 16 / 9;
    max-width: 80%;

    iframe,
    video {
      width: 100%;
      height: 100%;
    }
  }

  /* Tabbed content */
  .gl-tabs .gl-tabs-nav {
    margin-bottom: 0;
  }
  a.gl-tab-nav-item,
  a.gl-tab-nav-item:hover {
    border: 0;
    color: inherit;
    font-size: 1rem;
  }
  .gl-tab-nav-item-active:active,
  .gl-tab-nav-item-active:focus,
  .gl-tab-nav-item-active:focus:active {
    box-shadow: inset 0 -2px 0 0 var(--t-indigo-500), 0 0 0 1px var(--white);
    background: transparent;
  }
  .gl-tab-nav-item-active:focus-visible {
    box-shadow: 0 0 0 1px var(--white), 0 0 0 3px var(--blue-400);
  }
  .gl-tabs-nav li.nav-item {
    margin: 0;
  }
  .gl-tab-content {
    padding-top: 1rem;
    line-height: 1.5em;
    font-size: 1rem;
    p,
    ul,
    ol,
    code,
    pre {
      margin-top: 0;
    }

    .tab-pane p {
      margin-bottom: 1.5em;
    }

    ol {
      list-style-type: decimal;
      ol {
        list-style-type: lower-alpha;
      }
    }
  }

  /* Other elements */
  li {
    margin-bottom: 0.5rem;
  }

  img {
    border: 1px solid var(--gray-100);
    border-radius: 0.5rem;
    padding: 0.25rem;
    max-width: 100%;
  }
}

/* Deprecations page */
.deprecation-notes {
  font-size: .9rem;
  line-height: 1rem;
}
h2 .milestone-date {
  font-size: 1.25rem;
}

/* Help & Feedback */
.help-feedback {
  background-color: var(--t-indigo-50);
  width: 100%;
  border: 0;
  text-align: left;

  /* Help and Feedback button */
  button {
    border: 0;
    background: none;
    width: 100%;
    text-align: left;

    span {
      font-size: 1.067rem;
      font-weight: 700;
      margin: 0;
      color: var(--t-indigo-900);
    }
  }

  h3 {
    font-size: 1rem;
    font-weight: 700;
    margin: 0.75rem 0 0.25rem;
  }

  .feedback {
    flex: 0 0 60%;
  }
  .feedback p {
    margin-bottom: 0;
  }

  .help-feedback-container {
    button[aria-expanded="true"] .help-feedback-toggle{
      transform: rotate(-180deg);
      transition: 0.35s ease-in-out;
    }

    button[aria-expanded="false"] .help-feedback-toggle{
      transition: 0.35s ease-in-out;
    }
  }

  .help-feedback-toggle {
    width: 16px;
    height: 16px;
    mask: url("../gitlab_ui/svgs/chevron-lg-down.svg") no-repeat 50% 50%;
    mask-size: cover;
    background-color: var(--t-indigo-500);
    float: right;
  }

  .help-feedback-question-icon {
    width: 16px;
    height: 16px;
    margin: 4px 15px 0 0;
    mask: url("../gitlab_ui/svgs/question.svg") no-repeat 50% 50%;
    mask-size: cover;
    background-color: var(--t-indigo-500);
    float: left;
  }

  .gl-button:hover {
    border-bottom: 0;
  }
}

/* Footer */
ul.docs-footer-links a:hover,
.docs-footer-links-secondary a:hover {
  text-decoration: none;
  color: var(--gray-900);
}
.docs-footer-links-secondary a {
  color: var(--gray-500);
  padding-right: 1rem;
}
ul.docs-social a::before {
  background-repeat: no-repeat;
  content: "";
  display: inline-block;
  margin-left: 0.75rem;
  width: 18px;
  height: 18px;
}
/* FontAwesome social icons */
.twitter::before {
  background-image: url("../fa-icons/x-twitter.svg");
}
.facebook::before {
  background-image: url("../fa-icons/facebook.svg");
}
.linkedin::before {
  background-image: url("../fa-icons/linkedin.svg");
}
.youtube::before {
  background-image: url("../fa-icons/youtube.svg");
}
/* Override OneTrust button styles */
.ot-sdk-show-settings {
  all: unset;
  border: 0 !important;
  padding: 0 !important;
  color: var(--gray-500) !important;
  font-size: inherit !important;

  &:hover {
    background-color: inherit !important;
    color: var(--purple-900) !important;
  }
  &:focus {
    outline: none;
  }
}

/* Bootstrap-style collapsible sections */
.collapse {
  display: block;
  max-height: 0;
  overflow: hidden;
  transition: max-height .5s cubic-bezier(0, 1, 0, 1);
}
.collapse.show {
  max-height: 99em;
  transition: max-height .5s ease-in-out;
}
/* Needed for smooth collapse/expand */
.help-feedback .collapse:not(.show) {
  display: block;
}

/* Search */
nav.header {
  .search-form,
  .gs-wrapper,
  .gs-results {
    width: calc(100vw - 3rem);
    @media (min-width: 992px) {
      width: var(--search-lg-width);
    }
  }
  .gs-results {
    margin-top: 1px;
  }
  .search-form .input-group-append {
    background-color: inherit;
  }
}
.gl-search-box-by-type-input-borderless,
.gl-search-box-by-type-input-borderless.gl-form-input {
  padding: 0.5rem 1.75rem 0.5rem 2rem;
  border-radius: 0.125rem;
}
.gl-search-box-by-type-input-borderless.gl-form-input:not(.form-control-plaintext):focus,
.gl-search-box-by-type-input-borderless:not(.form-control-plaintext):focus {
  box-shadow: inset 0 0 0 2px var(--blue-400);
}
.gl-form-input.gl-search-box-by-click-input {
  height: auto;
}
.gs-wrapper kbd {
  display: none;
  @media (min-width: 992px) {
    display: inline;
    top: 0.25rem;
    right: 0.3rem;
    font-size: 0.75rem;
  }
}
.gs-results a:hover,
.gs-results a:focus {
  text-decoration: none;
  background-color: var(--gray-50);
  color: var(--gray-700);
  outline: none;
}
.gl-search-box-by-click {
  width: var(--search-lg-width);
}

/* Search overlay */
body.home .modal-backdrop {
  display: none;
}
.modal-backdrop {
  top: var(--header-height);
}

/* Search results page */
html:has(.template-search-results) {
  overflow-y: scroll;
}
.template-search-results .main-content {
  margin-right: 0;
}

/* Override styles for search results pagination element */
.gl-pagination {
  a {
    border-bottom: 0 !important;
  }

  .gl-pagination-item:not(.disabled).active:active {
    color: var(--white) !important;
  }
  .gl-pagination-item:not(.active) {
    color: var(--gl-action-neutral-foreground-color-default) !important;
  }

  .disabled .gl-pagination-item {
    border-color: var(--gl-border-color-transparent, var(--gl-color-alpha-0, transparent));
    background-color: transparent;
    color: var(--gl-action-disabled-foreground-color) !important;
  }
}

/* Pagefind UI overrides */
#search-container {
  a {
    color: var(--purple-700);
    text-decoration: none;
    border-bottom: 0;
  }

  button {
    background-color: transparent;
    border: 0;
  }

  .pagefind-ui__button { /* stylelint-disable-line selector-class-pattern */
    border: solid 1.5px var(--gray-100);
    color: var(--gray-500);
  }
}


/* 404 page */
html:has(.template-404) {
  overflow-y: scroll;
}
.template-404 {
  h1 {
    font-size: 2rem !important;
  }
}

/* Archive banner */
body.has-archive-banner {
  .gl-alert {
    width: 100%;
    position: fixed;
    top: var(--header-height);
    padding: 0.65rem 3rem;
    a {
      border-bottom: 1px solid var(--purple-700);
      color: var(--purple-700);
      text-decoration: none;
    }
  }
  .global-nav,
  th {
    top: calc(2 * var(--header-height));
  }
  .template-single {
    margin-top: 3rem !important;
  }
}

/**
 * Fill in styles that are missing from GitLab UI
*/
/* gl-display-block is still needed for GlDiscloseDropdown. See https://gitlab.com/gitlab-org/technical-writing/docs-gitlab-com/-/merge_requests/87/diffs#note_1935946247 */
.gl-display-block,
.gl-display-block\! { /* stylelint-disable-line selector-class-pattern */
  display: block !important;
}
/* Fixes the chevron icon. See https://gitlab.com/gitlab-org/gitlab-ui/-/issues/2095 */
.gl-form-select {
  background-image: url('data:image/svg+xml,%3Csvg width="8" height="5" viewBox="0 0 8 5" fill="none" xmlns="http://www.w3.org/2000/svg"%3E%3Cpath fill-rule="evenodd" clip-rule="evenodd" d="M0.21967 0.21967C0.512563 -0.0732232 0.987437 -0.0732232 1.28033 0.21967L4 2.93934L6.71967 0.21967C7.01256 -0.073223 7.48744 -0.0732229 7.78033 0.21967C8.07322 0.512563 8.07322 0.987437 7.78033 1.28033L4.53033 4.53033C4.23744 4.82322 3.76256 4.82322 3.46967 4.53033L0.21967 1.28033C-0.0732233 0.987437 -0.0732233 0.512563 0.21967 0.21967Z" fill="%23666666"/%3E%3C/svg%3E%0A');
}
/* Removes navigation tabs border radius */
a.gl-tab-nav-item {
  border-radius: 0 !important;
}

/* Feature flags table styles */
table.table-sortable {
  th.sortable {
    cursor: pointer;
  }
  th.sorted-asc::after,
  th.sorted-desc::after,
  th.sorted-default::after {
    content: "";
    width: 1rem;
    height: 1rem;
    display: inline-block;
    background-repeat: no-repeat;
    background-size: 90% 90%;
    background-position: bottom;
  }

  th.sorted-default::after {
    opacity: 0;
    background-image: url("../gitlab_ui/svgs/arrow-up.svg");
  }

  th.sorted-asc::after, th.sorted-default:hover::after  {
    opacity: 1;
    background-image: url("../gitlab_ui/svgs/arrow-up.svg");
  }

  th.sorted-desc::after{
    opacity: 1;
    background-image: url("../gitlab_ui/svgs/arrow-down.svg");
  }
}
